(ns org.domaindrivenarchitecture.fed-poc.forgefed
  (:require [clojure.spec.alpha :as s]
            [orchestra.core :refer [defn-spec]]
            [org.domaindrivenarchitecture.fed-poc.spec-helper :as sh]
            [org.domaindrivenarchitecture.fed-poc.activitystreams2 :as as]
            [org.domaindrivenarchitecture.fed-poc.xsd :as xsd]
            [org.domaindrivenarchitecture.fed-poc.activitystreams2 :as as]))

;https://forgefed.org/ns#Repository 
;TODO: definition in progress
(s/def ::Repository
  (s/and
   ::as/Object
   (sh/map-spec (s/keys :opt []))))

;https://forgefed.org/ns#Star
(s/def ::Star
  (s/merge
   ::as/Activity
   (sh/map-spec (s/keys :opt [::source]))))

;https://forgefed.org/ns#Unstar
(s/def ::Unstar
  (s/merge
   ::as/Activity
   (sh/map-spec (s/keys :opt [::source]))))

(s/def ::source
  (sh/seq-spec ::xsd/anyURI))