(ns org.domaindrivenarchitecture.fed-poc.forgefed-test
  (:require
   [clojure.test :refer [deftest is are testing run-tests]]
   [clojure.spec.alpha :as s]
   [org.domaindrivenarchitecture.fed-poc.security :as sec]
   [org.domaindrivenarchitecture.fed-poc.activitystreams2 :as as]
   [org.domaindrivenarchitecture.fed-poc.forgefed :as sut]))

(deftest Repository-test
  (is (s/valid? ::sut/Repository
                {::as/id "https://dev.example/aviva/treesim",
                 ::as/type "Repository",
                 :sec/publicKey {::sec/id "https://dev.example/aviva/treesim#main-key",
                                 ::sec/owner "https://dev.example/aviva/treesim",
                                 ::sec/publicKeyPem "-----BEGIN PUBLIC KEY-----\nMIIBIjANBgkqhki....."}, 
                 ::sut/inbox "https://dev.example/aviva/treesim/inbox",
                 ::sut/outbox "https://dev.example/aviva/treesim/outbox",
                 ::sut/followers "https://dev.example/aviva/treesim/followers",
                 ::sut/team "https://dev.example/aviva/treesim/team",
                 ::sut/name "Tree Growth 3D Simulation",
                 ::sut/summary "<p>Tree growth 3D simulator for my nature exploration game</p>"})))

(deftest Star-test
  (testing "stars for forgejo repositories"
    (testing "using activitypub api uris for id refernce"
      (is (s/valid? ::sut/Star
                    {::as/id "https://repo.prod.meissa.de/api/activitypub/user-id/1/outbox/12345",
                     ::as/type "Star",
                     ::sut/source "forgejo",
                     ::as/actor "https://repo.prod.meissa.de/api/activitypub/user-id/1",
                     ::as/object "https://codeberg.org/api/repos/forgejo/forgejo"})))))

(deftest Unstar-test
  (testing "stars for forgejo repositories"
    (testing "using activitypub api uris for id refernce"
      (is (s/valid? ::sut/Unstar
                    {::as/id "https://repo.prod.meissa.de/api/activitypub/user-id/1/outbox/12345",
                     ::as/type "Unstar",
                     ::sut/source "forgejo",
                     ::as/actor "https://repo.prod.meissa.de/api/activitypub/user-id/1",
                     ::as/object "https://codeberg.org/api/repos/forgejo/forgejo"})))))